/*
 * Legato is a configurable, lightweight web mapping client that can be
 * easily embedded into web pages and portals, CMS and individual web
 * applications. Legato is implemented in JavaScript and based on the
 * popular open source library OpenLayers.
 *
 * Copyright (C) 2010  disy Informationssysteme GmbH, http://www.disy.net
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Legato.Control.DrawMultiPolygon = OpenLayers.Class(Legato.Control.DrawFeature, {
  handlerConstructor : Legato.Handler.MultiPolygon,
  mode : 1,
  initialize : function(layer, options) {
    var that = this;

    this.callbacks = {
      done : function(geometry) {
        this.layer.events.triggerEvent('legato.sketchpointadded', {
          layer : this.layer,
          vertex : this.handler.point.geometry,
          geometry : geometry
        });
        that.drawFeature(geometry);
      }
    };

    Legato.Control.DrawFeature.prototype.initialize.apply(this, [ layer, options ]);
  },
  CLASS_NAME : 'Legato.Control.DrawMultiPolygon'
});

Legato.Control.DrawMultiPolygon.Bean = Legato.Control.DrawFeature.Bean.Extend(
//
'Legato.Control.DrawMultiPolygon',
//
Legato.Control.QName('DrawMultiPolygon'),
//
{
  _constructor : Legato.Control.DrawMultiPolygon,
  constructorArguments : {
    layer : OpenLayers.Layer.Bean
  },
  constructorOrder : [ 'layer' ]
});